searchNodes=[{"doc":"Functions for working with the HTS221The functionality is useful for use cases where you need complete control over the sensor or to debug the registers. If you just want to get started quickly see HTS221.Server module.To read registers you will need to provide a HTS221.Transport.t().{:ok, transport} = HTS221.Transport.init(HTS221.Transport.I2C, bus_name: &quot;i2c-1&quot;)Reading RegistersAfter opening the transport you can read or write registers.{:ok, %HTS221.Temperature{} = temp} = HTS221.read_temperature(transport)While this library provides some common helper functions to read particular registers it does not provide all the registers currently. However, the library does provide the HTS221.Register protocol and HTS221.read_register/2 that will allow you to provide support for any register.Writing RegistersTo write a register you will need to use HTS221.write_register/2.# this will provide the default register values ctrl_reg1 = %HTS221.CTRLReg1{} HTS221.write_register(transport, ctrl_reg1)CalibrationEach HTS221 is calibrated that the factory and the calibration that is stored in non-volatile memory is specific to each sensor. The calibration contains data about how to calculate the temperature and humidity and thus you will need to the calibration values to make those calculations.This library provides functionality for reading the calibration and using it to calculate the temperature and humidity.{:ok, %HTS221.Calibration{} = calibration} = HTS221.read_calibration(transport) {:ok, %HTS221.Temperature{} = temp} = HTS221.read_temperature(transport) temp_in_celsius = HTS221.calculate_temperature(temp, calibration)the same steps are required for calculating humidity","ref":"HTS221.html","title":"HTS221","type":"module"},{"doc":"Calculate the humidity from the HTS221.Humidity register valuesThis requires the HTS221.Calibration has the the humidity register values are the raw reading from the ADC. Each HTS221 is calibrated during manufacturing and contains the coefficients to required to convert the ADC values into percent.","ref":"HTS221.html#calculate_humidity/2","title":"HTS221.calculate_humidity/2","type":"function"},{"doc":"Calculate the temperature from the HTS221.Temperature register valuesThis requires the HTS221.Calibration has the the temperature register values are the raw reading from the ADC. Each HTS221 is calibrated during manufacturing and contains the coefficients to required to convert the ADC values into degrees celsius (default).","ref":"HTS221.html#calculate_temperature/3","title":"HTS221.calculate_temperature/3","type":"function"},{"doc":"Read the AV_CONF registerSee the HTS221.AVConfig module for more information.","ref":"HTS221.html#read_av_conf/1","title":"HTS221.read_av_conf/1","type":"function"},{"doc":"Read the calibration on the HTS221This is useful for checking the calibration on the hardware itself or fetch the calibration after any other register initialization and storing it for future calculations.{:ok, calibration} = HTS221.read_calibration(hts221) %HTS221{hts221 | calibration: calibration}","ref":"HTS221.html#read_calibration/1","title":"HTS221.read_calibration/1","type":"function"},{"doc":"Read the CTRL_REG1 registerSee the HTS221.CTRLReg1 module for more information.","ref":"HTS221.html#read_ctrl_reg1/1","title":"HTS221.read_ctrl_reg1/1","type":"function"},{"doc":"Read the values of the humidity registersThis function does not provided the final calculations of the humidity but only provides the functionality of reading the raw values in the register.","ref":"HTS221.html#read_humidity/1","title":"HTS221.read_humidity/1","type":"function"},{"doc":"Read any register that implements the HTS221.Register protocol","ref":"HTS221.html#read_register/2","title":"HTS221.read_register/2","type":"function"},{"doc":"Read the values of the temperature registersThis function does not provide the final calculations of the temperature but only provides the functionality of reading the raw values in the register.","ref":"HTS221.html#read_temperature/1","title":"HTS221.read_temperature/1","type":"function"},{"doc":"Write any register that implements the HTS221.Register protocol","ref":"HTS221.html#write_register/2","title":"HTS221.write_register/2","type":"function"},{"doc":"","ref":"HTS221.html#t:opt/0","title":"HTS221.opt/0","type":"type"},{"doc":"Signed 16-bit integer","ref":"HTS221.html#t:s16/0","title":"HTS221.s16/0","type":"type"},{"doc":"The scale in which the temperature is calculated (default :celsius)","ref":"HTS221.html#t:scale/0","title":"HTS221.scale/0","type":"type"},{"doc":"Register for reading and writing the level temperature and humidity averageBy default the average is calculated off of 16 temperature samples and 32 humidity samples.The more samples the less degree of error in the reading, however that also will cause the HTS221 to draw more power. Check the data sheet section 7.2 for more information.","ref":"HTS221.AVConf.html","title":"HTS221.AVConf","type":"module"},{"doc":"","ref":"HTS221.AVConf.html#from_binary/1","title":"HTS221.AVConf.from_binary/1","type":"function"},{"doc":"","ref":"HTS221.AVConf.html#to_binary/1","title":"HTS221.AVConf.to_binary/1","type":"function"},{"doc":"","ref":"HTS221.AVConf.html#t:humidity_sample/0","title":"HTS221.AVConf.humidity_sample/0","type":"type"},{"doc":"","ref":"HTS221.AVConf.html#t:t/0","title":"HTS221.AVConf.t/0","type":"type"},{"doc":"","ref":"HTS221.AVConf.html#t:temperature_sample/0","title":"HTS221.AVConf.temperature_sample/0","type":"type"},{"doc":"Control the power state, data rate, and update strategy of the HTS221","ref":"HTS221.CTRLReg1.html","title":"HTS221.CTRLReg1","type":"module"},{"doc":"Parse the binary into a HTS221.CTRLReg1 structure","ref":"HTS221.CTRLReg1.html#from_binary/1","title":"HTS221.CTRLReg1.from_binary/1","type":"function"},{"doc":"Turn the HTS221.CTRLReg1 structure into a binary to be sent to the transport layer","ref":"HTS221.CTRLReg1.html#to_binary/1","title":"HTS221.CTRLReg1.to_binary/1","type":"function"},{"doc":"","ref":"HTS221.CTRLReg1.html#t:block_data_update/0","title":"HTS221.CTRLReg1.block_data_update/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg1.html#t:output_data_rate/0","title":"HTS221.CTRLReg1.output_data_rate/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg1.html#t:power_mode/0","title":"HTS221.CTRLReg1.power_mode/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg1.html#t:t/0","title":"HTS221.CTRLReg1.t/0","type":"type"},{"doc":"Control the memory boot, heater element, and one shot initialization for the HTS221","ref":"HTS221.CTRLReg2.html","title":"HTS221.CTRLReg2","type":"module"},{"doc":"Parse a binary register response into the HTS221.CTRLReg2 structure","ref":"HTS221.CTRLReg2.html#from_binary/1","title":"HTS221.CTRLReg2.from_binary/1","type":"function"},{"doc":"Make a HTS221.CTRLReg2 structure into a binary string to be written to the register","ref":"HTS221.CTRLReg2.html#to_binary/1","title":"HTS221.CTRLReg2.to_binary/1","type":"function"},{"doc":"","ref":"HTS221.CTRLReg2.html#t:boot_mode/0","title":"HTS221.CTRLReg2.boot_mode/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg2.html#t:heater_mode/0","title":"HTS221.CTRLReg2.heater_mode/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg2.html#t:one_shot/0","title":"HTS221.CTRLReg2.one_shot/0","type":"type"},{"doc":"","ref":"HTS221.CTRLReg2.html#t:t/0","title":"HTS221.CTRLReg2.t/0","type":"type"},{"doc":"The calibration for the HTS221Each HTS221 is calibrated at the factory and has an unique calibration. The calibration is used to calculate the temperature and humidity values that are stored in the registers as those values are raw ADC values.","ref":"HTS221.Calibration.html","title":"HTS221.Calibration","type":"module"},{"doc":"","ref":"HTS221.Calibration.html#from_binary/1","title":"HTS221.Calibration.from_binary/1","type":"function"},{"doc":"","ref":"HTS221.Calibration.html#h0/1","title":"HTS221.Calibration.h0/1","type":"function"},{"doc":"","ref":"HTS221.Calibration.html#h1/1","title":"HTS221.Calibration.h1/1","type":"function"},{"doc":"","ref":"HTS221.Calibration.html#t0/1","title":"HTS221.Calibration.t0/1","type":"function"},{"doc":"","ref":"HTS221.Calibration.html#t1/1","title":"HTS221.Calibration.t1/1","type":"function"},{"doc":"","ref":"HTS221.Calibration.html#t:t/0","title":"HTS221.Calibration.t/0","type":"type"},{"doc":"Humidity RegistersThis module is useful for reading the values from the humidity registers (0x28, 0x29) and providing both the individual readings and the complete raw 16-bit integer.","ref":"HTS221.Humidity.html","title":"HTS221.Humidity","type":"module"},{"doc":"","ref":"HTS221.Humidity.html#from_binary/1","title":"HTS221.Humidity.from_binary/1","type":"function"},{"doc":"","ref":"HTS221.Humidity.html#t:t/0","title":"HTS221.Humidity.t/0","type":"type"},{"doc":"Data structure that provides information about how to read registersThis is only useful if you are implementing the HTS221.Register protocol.If the :length field is more than one, then the read will read length number of registers sequentially.For example:%HTS221.IORead{ register: 0x01, length: 5 }This will read registers 0x01 to 0x05 and provide a 5 byte binary string.","ref":"HTS221.IORead.html","title":"HTS221.IORead","type":"module"},{"doc":"Create a new HTS221.IORead data structure","ref":"HTS221.IORead.html#new/2","title":"HTS221.IORead.new/2","type":"function"},{"doc":"","ref":"HTS221.IORead.html#t:t/0","title":"HTS221.IORead.t/0","type":"type"},{"doc":"Data structure about writing to registersThis is only useful if you are implementing the HTS221.Register protocol.This only has one field :payload but the register you writing to should be the first byte in the binary.register = 0x01 %HTS221.IOWrite{ payload: &lt;&lt;register, 0x01&gt;&gt; }The above example says to write 0x01 to the 0x01 register.","ref":"HTS221.IOWrite.html","title":"HTS221.IOWrite","type":"module"},{"doc":"Create a new HTSS221.IOWrite data structure","ref":"HTS221.IOWrite.html#new/1","title":"HTS221.IOWrite.new/1","type":"function"},{"doc":"","ref":"HTS221.IOWrite.html#t:t/0","title":"HTS221.IOWrite.t/0","type":"type"},{"doc":"Protocol for turning a data structure into an IO request that a transport can use to read and/or write to the HTS221","ref":"HTS221.Register.html","title":"HTS221.Register","type":"protocol"},{"doc":"Make the data structure into an HTS221.IOReadIf the register should not be read return {:error, :access_error}.","ref":"HTS221.Register.html#read/1","title":"HTS221.Register.read/1","type":"function"},{"doc":"Make the data structure into an HTS221.IOWriteIf the register should not be written return {:error, :access_error}.","ref":"HTS221.Register.html#write/1","title":"HTS221.Register.write/1","type":"function"},{"doc":"","ref":"HTS221.Register.html#t:t/0","title":"HTS221.Register.t/0","type":"type"},{"doc":"Server for setting up and using the HTS221When controlling the HTS221 there are few setup steps and other checks you may want to do. Also, to keep the transport layer working often times this will call for a GenServer. This server is meant to provide common functionality around setup and an expose a higher level API for application use.This process can be added to your supervision tree.def MyApp do use Application def start(_type, _args) do children = [ ... children ... {HTS221.Server, transport: {HTS221.Transport.I2C, [bus_name: &quot;i2c-1&quot;]} ... children ... ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start(children, opts) end endIf you a custom transport implementation then the :transport argument to this server will look different.If the HTS221 is not detected this server will log that it was not found and return :ignore on the GenServer.init/1 callback. This is useful if your FW will run on devices with different hardware attached and don't want the device availability to crash your application supervisor.","ref":"HTS221.Server.html","title":"HTS221.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"HTS221.Server.html#child_spec/1","title":"HTS221.Server.child_spec/1","type":"function"},{"doc":"Read the humidity levelThis is measured in percent.","ref":"HTS221.Server.html#humidity/1","title":"HTS221.Server.humidity/1","type":"function"},{"doc":"","ref":"HTS221.Server.html#start_link/1","title":"HTS221.Server.start_link/1","type":"function"},{"doc":"Read the temperature valueBy default this is read in celsius you can the :scale option to change the unit the temperature is measured in. See HTS221.scale() for more information.","ref":"HTS221.Server.html#temperature/2","title":"HTS221.Server.temperature/2","type":"function"},{"doc":"Get the transport the server is usingThis is useful if you need to debug the registers using the functions in HTS221 module.","ref":"HTS221.Server.html#transport/1","title":"HTS221.Server.transport/1","type":"function"},{"doc":"Arguments to the HTS221.Server:transport - the transport implementation module and optional arguments:name - this is a named GenServer that either uses what you pass in or HTS221.Server","ref":"HTS221.Server.html#t:arg/0","title":"HTS221.Server.arg/0","type":"type"},{"doc":"","ref":"HTS221.Server.html#t:name/0","title":"HTS221.Server.name/0","type":"type"},{"doc":"","ref":"HTS221.Server.html#t:temperature_opt/0","title":"HTS221.Server.temperature_opt/0","type":"type"},{"doc":"Temperature RegistersThis module abstracts over the two temperature registers (0x2A, 0x2B) and provide functionally to read both at once to provide the raw ADC data on in the two registers.","ref":"HTS221.Temperature.html","title":"HTS221.Temperature","type":"module"},{"doc":"","ref":"HTS221.Temperature.html#from_binary/1","title":"HTS221.Temperature.from_binary/1","type":"function"},{"doc":"","ref":"HTS221.Temperature.html#t:t/0","title":"HTS221.Temperature.t/0","type":"type"},{"doc":"A behaviour to communicate to the HTS221","ref":"HTS221.Transport.html","title":"HTS221.Transport","type":"behaviour"},{"doc":"Initialize the transport implementation","ref":"HTS221.Transport.html#c:init/1","title":"HTS221.Transport.init/1","type":"callback"},{"doc":"Helper function initializing the transport implementation","ref":"HTS221.Transport.html#init/2","title":"HTS221.Transport.init/2","type":"function"},{"doc":"Read the register","ref":"HTS221.Transport.html#c:read_register/3","title":"HTS221.Transport.read_register/3","type":"callback"},{"doc":"Send the IO request to the HTS221","ref":"HTS221.Transport.html#send/2","title":"HTS221.Transport.send/2","type":"function"},{"doc":"Write the register","ref":"HTS221.Transport.html#c:write_register/2","title":"HTS221.Transport.write_register/2","type":"callback"},{"doc":"Arguments for the implementation init/1 callbackSee the implementation's docs to see what the arguments are.","ref":"HTS221.Transport.html#t:arg/0","title":"HTS221.Transport.arg/0","type":"type"},{"doc":"The underline communication data structure for the transport implementation to use when sending data to the HTS221.For example in Circuits.I2C the data structure is a reference.","ref":"HTS221.Transport.html#t:comm/0","title":"HTS221.Transport.comm/0","type":"type"},{"doc":"A module that implements the HTS221.Transport behaviour","ref":"HTS221.Transport.html#t:impl/0","title":"HTS221.Transport.impl/0","type":"type"},{"doc":"","ref":"HTS221.Transport.html#t:t/0","title":"HTS221.Transport.t/0","type":"type"},{"doc":"I2C implementation of the HTS221.Transport behaviourArgs::bus_name - the string of the I2C bus: i2c-1","ref":"HTS221.Transport.I2C.html","title":"HTS221.Transport.I2C","type":"module"},{"doc":"HTS221An Elixir library for working with the HTS221 sensor. This sensor reports relative humidity and temperature.For more information about the HTS221 sensor please see the resources section below.","ref":"readme.html","title":"HTS221","type":"extras"},{"doc":"The package can be installed by adding hts221 to your list of dependencies in mix.exs:def deps do [ {:hts221, &quot;~&gt; 0.2.1&quot;} ] end","ref":"readme.html#installation","title":"HTS221 - Installation","type":"extras"},{"doc":"Quick StartThis is assuming the HTS221 is using I2C.{:ok, _pid} = HTS221.Server.start_link(transport: {HTS221.Transport.I2C, [bus_name: &quot;i2c-1&quot;]}) temp = HTS221.Server.temperature(HTS221.Server) hum = HTS221.Server.humidity(HTS221.Server)TransportsTo use the HTS221 you will need to provide a module that implements the HTS221.Transport behaviour. This library provides the HTS221.Transport.I2C module if you are using the HTS221 in I2C mode.{:ok, transport} = HTS221.Transport.init(HTS221.Transport.I2C, bus_name: &quot;i2c-1&quot;)CalibrationThe HTS221 calibration contains read-only data about the coefficients for calculating the temperature in celsius and the humidity in percent. These values are calibrated at the factory for each HTS221 sensor, so they are unique to each sensor. In order to calcuate the temperature and the humidity you will need to read the calibration and use that with the HTS221.calculate_temperature/2 and HTS221.calculate_humidity/2 functions.To read the calibration use the HTS221.read_calibration/1 function:{:ok, %HTS221.Calibration{} = calibration} = HTS221.read_calibration(transport)Power ModeBy default the HTS221 is in &quot;power-down&quot; mode, which means the sensor will not any new readings. In order to enable the sensor to take new readings you can set the HTS221.CTRLReg1 register to use :active for its power mode.ctrl_reg1 = %HTS221.CTRLReg1{ power_mode: :active } :ok = HTS221.write_register(transport, ctrl_reg1)However, by default the sensor's output data rate (ORD) is set to :one_shot. This means that you will need to trigger a new reading via the CTRL_REG2. If you want the sensor to read without needing to trigger a new reading you can set the CTRL_REG2 up like this:ctrl_reg1 = %HTS221.CTRLReg1{ power_mode: :active, output_data_rate: :one_Hz } :ok = HTS221.write_register(transport, ctrl_reg1)For best data consistency though you will want to set the :block_data_update field to :wait_for_reading. The recommend base CTRL_REG1 configuration should look like:ctrl_reg1 = %HTS221.CTRLReg1{ power_mode: :active, output_data_rate: :one_Hz, block_data_update: :wait_for_reading } :ok = HTS221.write_register(transport, ctrl_reg1)Read and Calculate Temperature{:ok, %HTS221.Calibration{} = calibration} = HTS221.read_calibration(transport) {:ok, %HTS221.Temperature{} = temp} = HTS221.read_temperature(transport) HTS221.calculate_temperature(temp, calibration) Read and Calculate Humidity{:ok, %HTS221.Calibration{} = calibration} = HTS221.read_calibration(transport) {:ok, %HTS221.Humidity{} = hum} = HTS221.read_humidity(transport) HTS221.calculate_temperature(hum, calibration)","ref":"readme.html#usage","title":"HTS221 - Usage","type":"extras"},{"doc":"DocsHTS221 datasheetInterpreting humidity and temperature readingsRecommended HardwareThe hardware below is what I have used to develop, however this should would with any supported hardware that Nerves supports.PMOD HTS221Raspberry PI PMOD HatRaspberry PI zero","ref":"readme.html#resources","title":"HTS221 - Resources","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"ChangedWhen running the HTS221.Server it would crash on start when the HTS221 sensor was not on the bus. This is an issue when a device my optionally have the sensor. Now it shutdown gracefully and log that the HTS221 sensor was not found on the bus.","ref":"changelog.html#v0-2-1-2020-9-16","title":"Changelog - v0.2.1 [2020-9-16]","type":"extras"},{"doc":"This is a complete rewrite. Please read README and moduledocs for new API","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Updates circuits_i2c to prevent bugs in non nerves environments","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Initial release!","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]